/*
 * Copyright 2021 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef OUTPUT_H__
#define OUTPUT_H__

typedef enum {
    PRINT_INFO,
    PRINT_INFO_NONL,
    PRINT_WARN,
    PRINT_DIE
} PRINT;

extern void Output(Sys* pSys,PRINT ePrint,int iErr,const char* pcFmt,va_list ap);
extern void WarnOrDie(Sys* pSys,PRINT ePrint,int iErr,const char* pcFmt,va_list ap);
extern void Info(Sys* pSys,const char* pcFmt,...)
    __attribute__ ((format (printf, 2, 3)));
extern void Verbose(Sys* pSys,const char* pcFmt,...)
    __attribute__ ((format (printf, 2, 3)));
extern void Warn(Sys* pSys,int iErr,const char* pcFmt,...)
    __attribute__ ((format (printf, 3, 4)));
extern __attribute__((noreturn)) void Die(Sys* pSys,int iErr,const char* pcFmt,...)
    __attribute__ ((format (printf, 3, 4)));

#endif  /* OUTPUT_H__ */
