/*
 * Copyright 2021 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "common.h"
#include "r5_sys_mutex.h"

void r5GrabSysMutex(void)
{
    volatile uint32_t* pqReg = (volatile uint32_t*)0xF1111100;

    for(;;) {
        *pqReg = R5_MASTER_ID;
        if(R5_MASTER_ID == *pqReg) {
            break;
        }
    }
}

void r5ReleaseSysMutex(void)
{
   *(volatile uint32_t*)0xF1111100 = 0;
}
