/*
 * Copyright 2021 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef R5_SYS_MUTEX_H__
#define R5_SYS_MUTEX_H__

#if defined(psv_cortexr5_0) || defined(psv_cortexr5_lockstep)
#define R5_MASTER_ID    0x200
#elif defined(psv_cortexr5_1)
#define R5_MASTER_ID    0x204
#else
#error Unknown r5 processor
#endif

/*
 * Grab system mutex #0
 * Spin until it is becomes free
 */
void r5GrabSysMutex(void);

/*
 * Release previously grabbed system mutex #0
 */
void r5ReleaseSysMutex(void);

#endif  /* R5_SYS_MUTEX_H__ */
