/*
 * Copyright 2021 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef X86_R5_DEVICE_H__
#define X86_R5_DEVICE_H__

struct R5Data;
typedef struct R5Data R5Data;

/*
 * 2MiB: This is the minimum size of the BAR that exposes the TCM+OCM
 */
#define R5_MAP_MIN_SIZE     (2*1024*1024)

/*
 * The offsets are from the beginning of TCM
 * The TCM offset in the PCIe BAR is specified in the board configuration
 */
#define R5_MESSAGE_AREA_OFFSET  (60*1024)
#define R5_AUX_AREA_OFFSET      (0xfffc0000 - 0xffe00000)

struct R5Data {
    void* pxMap;
    uint32_t qMapSize;
};

bool OpenR5(Sys* pSys);
bool CloseR5(Sys* pSys);

#endif  /* X86_R5_DEVICE_H__ */
